/*
	This code section was taken from our project 2 lab.  It is nearly identical.
*/
unsigned int OldButtonState; 
unsigned char OldKeypadState;
char FilledKeypadBuffer;
char CurrentStringBuffer[3];
int CurrentStringBuffer_CurrentIndex; 
const unsigned int ONE = 0x1;
#define Button0         0b0000000000000001
#define Button1         0b0000000000000010
#define Button2         0b0000000000000100
#define Button3         0b0000000000001000
#define Button4         0b0000000000010000
#define Button5         0b0000000000100000
#define Button6         0b0000000001000000
#define Button7         0b0000000010000000
#define Button8         0b0000000100000000
#define Button9         0b0000001000000000
#define ButtonA         0b0000010000000000
#define ButtonB         0b0000100000000000
#define ButtonC         0b0001000000000000
#define ButtonD         0b0010000000000000
#define ButtonE         0b0100000000000000
#define ButtonF         0b1000000000000000  
void KeyboardEntryHandler(unsigned char CurrentKeypadState) // this is a task ... 
{                                             

    // figure out what buttons are on ... (on is 1)
	/*
		In order to determine which key was pressed, we call the KeyboardEntryHandler and 
		pass it the current key pad state.  There are 16 different possibilities as to 
		which keys can be pressed and therefore we have 16 if statements that try and 
		determine which button is pressed.  We create a 16-bit mask to represent which 
		buttons are pressed and which arent.  If an if statement determines that that 
		buttons is pressed, then it sets the appropriate bit in the mask, otherwise it 
		is left unset.  Just as we stored the old key pad state, we also save the buttons 
		state, or which buttons are down.  Now, we could actually get away with just one 
		of these states, and convert it on the fly from one to the other, but when one is 
		more concerned with performance, over a simple 16 bit number, then speed wins. 
		Since we have access to both, it is very easy to determine if the keypad state 
		changed, and it is also very easy to tell if a button is pressed.  Additionally, 
		our model for ready the keypad may allow us in the future to support multiple 
		button presses, things like key-up and key-down, and a repeating key-press. 
	*/
	unsigned int CurrentButtonState = 0;
	unsigned char i;
	unsigned char OldButtonIndexDown;
	unsigned int ButtonBitRepresentation;
	if((~CurrentKeypadState & 0b00010001) == 0b00010001) CurrentButtonState = CurrentButtonState | Button1;
	if((~CurrentKeypadState & 0b00010010) == 0b00010010) CurrentButtonState = CurrentButtonState | Button2;
	if((~CurrentKeypadState & 0b00010100) == 0b00010100) CurrentButtonState = CurrentButtonState | Button3;
	if((~CurrentKeypadState & 0b00011000) == 0b00011000) CurrentButtonState = CurrentButtonState | ButtonA;
	if((~CurrentKeypadState & 0b00100001) == 0b00100001) CurrentButtonState = CurrentButtonState | Button4;
	if((~CurrentKeypadState & 0b00100010) == 0b00100010) CurrentButtonState = CurrentButtonState | Button5;
	if((~CurrentKeypadState & 0b00100100) == 0b00100100) CurrentButtonState = CurrentButtonState | Button6;
	if((~CurrentKeypadState & 0b00101000) == 0b00101000) CurrentButtonState = CurrentButtonState | ButtonB;
	if((~CurrentKeypadState & 0b01000001) == 0b01000001) CurrentButtonState = CurrentButtonState | Button7;
	if((~CurrentKeypadState & 0b01000010) == 0b01000010) CurrentButtonState = CurrentButtonState | Button8;
	if((~CurrentKeypadState & 0b01000100) == 0b01000100) CurrentButtonState = CurrentButtonState | Button9;
	if((~CurrentKeypadState & 0b01001000) == 0b01001000) CurrentButtonState = CurrentButtonState | ButtonC;
	if((~CurrentKeypadState & 0b10000001) == 0b10000001) CurrentButtonState = CurrentButtonState | Button0;
	if((~CurrentKeypadState & 0b10000010) == 0b10000010) CurrentButtonState = CurrentButtonState | ButtonF;
	if((~CurrentKeypadState & 0b10000100) == 0b10000100) CurrentButtonState = CurrentButtonState | ButtonE;
	if((~CurrentKeypadState & 0b10001000) == 0b10001000) CurrentButtonState = CurrentButtonState | ButtonD;

    // find the index of the bit that changed ...
	/*
		So, since we have a 16-bit mask as to which buttons are pressed we can go through 
		our saved state and compare them.  If there is difference in any bit index, then 
		if it was up, now it is down and we should register a button down.  On the other
		hand if it was down and now its up, then we could register a button up, but as 
		we said above, this is not required for	this lab.  Therefore we only consider doing
		special processing if the button goes from an 	up state to a down state.  
		In this case we keep a running string (character array) of all	of the buttons 
		that have been pressed when the enter key has not yet been pressed.  It basically
		serves as a buffer to keep the text/number in until the user presses the enter 
		button.  Therefore whenever any numerical key (we are only considering the user 
		entering numbers in decimal for this lab) is pressed, we append it to the buffer
		and increment the size of the buffer (not the actual size of the array, just the
		index of the last character	in the array, plus one). Our keypad did not have an 
		enter button, so we chose to use the lower rightmost button, of the D key.  We
		remember that when we hit enter, we actually terminate the string/number with a 
		null character so that it can be passed to the atoi function, which converts a 
		character array that represents an integer value to its actual integer value.  
		Also when enter is pressed we signal that there is a string to be processed.  

		NOTE: It is up to the consuming task to set this flag back to zero.
	*/
	for(i=0;i<16;i++)
	{      
		ButtonBitRepresentation = ONE << i;
		// if this button changed
		if( (OldButtonState & (ONE << i)) != (CurrentButtonState & (ONE << i)) )
		{
			// did it used to be down?
			OldButtonIndexDown = ((OldButtonState & (ONE << i)) != 0);
			// if it was down, then we process a key up (which is nothing)
			if ( OldButtonIndexDown ) CurrentButtonState = CurrentButtonState | (ONE << i);   
			else
			{       
				CurrentButtonState = CurrentButtonState & ~((ONE << i));
				// if a "number" key was pressed
				if(ButtonBitRepresentation >= Button0 && ButtonBitRepresentation <= Button9) // pushed a number
				{                                                                             
					CurrentStringBuffer[CurrentStringBuffer_CurrentIndex++] = i;
					// reset after 2 "key" presses and set the flag.
					if(CurrentStringBuffer_CurrentIndex > 1)
					{
						CurrentStringBuffer_CurrentIndex = 0;
						FilledKeypadBuffer = 1;
					}
				}
			}
		}
	}
}
/*
	The keypad state was read every 30 milliseconds.  This is because we were 
	taught that in order to de-bounce the keypad we would need to change states
	only every 30 milliseconds.
*/
void KeyboardHandler_Test()
{
	unsigned char CurrentKeypadState = 0;
	// read the keypad ... 
	DDRB = 0x0F;
	PORTB = 0xF0;
	delay_us(5);
	CurrentKeypadState = PINB; 
	DDRB = 0xF0;
	PORTB = 0x0F;
	delay_us(5);
	CurrentKeypadState = CurrentKeypadState | PINB;
	/*
		Every 30 ms we save a copy of the current state of the keypad and if we 
		detect a change from that old keypad state to the new/current keypad state,
		we attempt to figure out which button was either pressed or released.  
	*/
	if(OldKeypadState != CurrentKeypadState)
	{      
		// there was a change in the button state ... 
		KeyboardEntryHandler(CurrentKeypadState);
		OldKeypadState = CurrentKeypadState;
	}
}